/**************************************************************
*Author = Wee Jin Goh.
*email  = wjgoh@gdnmail.net
*Program = This program is used to find the IP when given a DNS,
*		   or to find the DNS, if it is given the IP.
***************************************************************/

/*@@ Wedit generated application. Written Mon May 05 13:39:19 2003
 @@header: c:\lcc\projects\ipresolve\ipresolveres.h
 @@resources: c:\lcc\projects\ipresolve\ipresolve.rc
 Do not edit outside the indicated areas */
/*<---------------------------------------------------------------------->*/
/*<---------------------------------------------------------------------->*/
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include <winsock.h>
#include <stdio.h>
#include "ipresolveres.h"
/* --- The following code comes from c:\lcc\lib\wizard\dlgbased.tpl. */
/*<---------------------------------------------------------------------->*/

/*
Template for a dialog based application. The main procedure for this
template is the DialogFunc below. Modify it to suit your needs.
*/
/* prototype for the dialog box function. */
static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);
void DialogFunc_OnGetIP(HWND hDlg);
void DialogFunc_OnGetDNS(HWND hDlg);
/*
Win main just registers a class of the same type that the dialog class, and
then calls DialogBox. Then it exits. The return value is the return value of
the dialog procedure.
*/

int APIENTRY WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wc;

	memset(&wc,0,sizeof(wc));
	wc.lpfnWndProc = DefDlgProc;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hinst;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = LoadIcon(hinst, MAKEINTRESOURCE(IDB_IPRESOLVE));
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszClassName = "ipresolve";
	RegisterClass(&wc);


	return DialogBox(hinst, MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, (DLGPROC) DialogFunc);

}

/*
You should add your initialization code here. This function will be called
when the dialog box receives the WM_INITDIALOG message.
*/
static int InitializeApp(HWND hDlg,WPARAM wParam, LPARAM lParam)
{
	WSADATA wsaData;
	WSAStartup(MAKEWORD(2,0), &wsaData);
	return 1;
}

/*
This is the main function for the dialog. It handles all messages. Do what your
application needs to do here.
*/
static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
	/* This message means the dialog is started but not yet visible.
	   Do All initializations here
        */
	case WM_INITDIALOG:
		InitializeApp(hwndDlg,wParam,lParam);
		return TRUE;
	/* By default, IDOK means close this dialog returning 1, IDCANCEL means
           close this dialog returning zero
        */
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			case IDC_GET_IP:
				DialogFunc_OnGetIP(hwndDlg);
				break;

			case IDC_GET_DNS:
				DialogFunc_OnGetDNS(hwndDlg);
				break;
		}
		break;
        /* By default, WM_CLOSE is equivalent to CANCEL */
	case WM_CLOSE:
		WSACleanup();
		EndDialog(hwndDlg,0);
		return TRUE;

	}
	return FALSE;
}


/*********************
*Handle the user clicking IDC_GET_IP
**********************/
void DialogFunc_OnGetIP(HWND hDlg)
{
	struct hostent *h;
	char dns[MAX_PATH];
	char ip[MAX_PATH];

	GetDlgItemText(hDlg, IDC_DNS, dns, MAX_PATH);

	h = gethostbyname(dns);
	if(h == NULL) {
		MessageBox(NULL, "Error finding IP", "DNS does not exist", MB_ICONSTOP|MB_OK);
		return;
	}

	sprintf(ip, "%s", inet_ntoa(*(struct in_addr *)h->h_addr));
	SetDlgItemText(hDlg, IDC_IP, ip);

}


/*********************************************
*Handle the user clicking IDC_GET_DNS
*********************************************/
void DialogFunc_OnGetDNS(HWND hDlg)
{
	struct hostent *h;
	char dns[MAX_PATH];
	char ip[MAX_PATH];

	GetDlgItemText(hDlg, IDC_IP, ip, MAX_PATH);

	struct in_addr addr;
	addr.s_addr = inet_addr(ip);
	h = gethostbyaddr((const char *)&addr, sizeof(struct in_addr), AF_INET);
	if(h == NULL) {
		MessageBox(NULL, "Error finding IP...", "Host not found", MB_OK| MB_ICONSTOP);
		return;
	}

	sprintf(dns, "%s", h->h_name);
	SetDlgItemText(hDlg, IDC_DNS, dns);

}

